<?php
add_action('media_buttons', 'add_superbed_upload_button');
function add_superbed_upload_button()
{
    if (!empty(wp_get_current_user()->roles) && in_array('administrator', wp_get_current_user()->roles)) {
        $getdataToken = get_option('token');
        $getdataCategories = get_option('categories');
    } else
        return 0;
    ?>
    <link href="<?php echo plugin_dir_url(__FILE__); ?>assets/style.css" type="text/css" rel="stylesheet" />
    <a href="javascript:;" class="superbed-upload"><input type="file" id="input-superbed-upload" multiple />上传图片</a>
    <!-- span id="tip">上传图片过程中请耐心等待！请勿刷新页面</span -->
    <script src="//lib.baomitu.com/axios/0.27.2/axios.min.js"></script>
    <script>
        function showToast(msg) {
            let toastNode = `<div class="toast-content"><div class="toast"><span>${msg}</span></div></div>`;
            document.body.insertAdjacentHTML('beforeend', toastNode);
            setTimeout(function () {
                document.body.removeChild(document.querySelector('.toast-content'))
            }, 3000)
        }
        function copyData(data) {
            let textNode = `<textarea id="copyFrom" style="position:absolute;top:-1000px;left:-1000px;">${data}</textarea>`;
            document.body.insertAdjacentHTML('beforeend', textNode);
            document.querySelector('#copyFrom').select();
            document.execCommand("copy");
            document.body.removeChild(document.querySelector('#copyFrom'));
            showToast("链接已复制到剪切板");
        }

        const superbed_upload = document.getElementById('input-superbed-upload');
        superbed_upload.addEventListener("change", () => {
            const files = superbed_upload.files;
            for (let i = 0; i < files.length; i++) {
                const file = files[i];
                const formData = new FormData();
                formData.append('file', file);
                formData.append('token', "<?php echo get_option('token'); ?>");
                formData.append('categories', "<?php echo get_option('categories'); ?>");
                document.getElementById('input-superbed-upload').disabled = true;
                document.getElementById('tip').innerHTML = '正在上传中...';
                axios.defaults.crossDomain = true;
                axios({
                    method: 'post',
                    url: 'https://api.superbed.cc/upload',
                    data: formData,
                    headers: {
                        'Access-Control-Allow-Origin': '*',
                        'Access-Control-Allow-Methods': 'POST',
                        'Access-Control-Allow-Headers': 'Content-Type',
                        'Accept': 'application/json',
                        'Content-Type': 'multipart/form-data',
                    }
                }).then(response => {
                    const data = response.data;
                    if (data.err == 0) {
                        const url = data.url;
                        const name = data.name;
                        copyData(url);
                        wp.media.editor.insert('<a href="' + url + '"><img src="' + url + '" alt="' + name + '" /></a>');
                        document.getElementById('input-superbed-upload').disabled = false;
                    } else {
                        showToast(data.msg);
                        document.getElementById('input-superbed-upload').disabled = false;
                        document.getElementById('tip').innerHTML = data.msg;
                    }
                }).catch(error => {
                    showToast("网络错误请重试");
                    console.log(error);
                    document.getElementById('input-superbed-upload').disabled = false;
                });
            }
        });
    </script>
<?php }


add_action('add_meta_boxes', 'add_superbed_upload_box');
function add_superbed_upload_box()
{
    if (!empty(wp_get_current_user()->roles) && in_array('administrator', wp_get_current_user()->roles)) {
        add_meta_box('superbed_upload_box', '聚合图床上传', 'superbed_upload_box', 'post', 'side', 'high');
        $getdataToken = get_option('token');
        $getdataCategories = get_option('categories');
    } else
        return 0;
}
function superbed_upload_box()
{ ?>
    <link href="<?php echo plugin_dir_url(__FILE__); ?>assets/style.css" type="text/css" rel="stylesheet" />
    <div id="superbed-upload-box">点击此区域上传图片</div>
    <input type="file" multiple id="superbed-upload-box-input" />
    <div id="result"></div>
    <script src="//lib.baomitu.com/axios/0.27.2/axios.min.js"></script>
    <script>
        function showToast(msg) {
            let toastNode = `<div class="toast-content"><div class="toast"><span>${msg}</span></div></div>`;
            document.body.insertAdjacentHTML('beforeend', toastNode);
            setTimeout(function () {
                document.body.removeChild(document.querySelector('.toast-content'))
            }, 3000)
        }
        function copyData(data) {
            let textNode = `<textarea id="copyFrom" style="position:absolute;top:-1000px;left:-1000px;">${data}</textarea>`;
            document.body.insertAdjacentHTML('beforeend', textNode);
            document.querySelector('#copyFrom').select();
            document.execCommand("copy");
            document.body.removeChild(document.querySelector('#copyFrom'));
            showToast("链接已复制到剪切板");
        }

        const superbed_upload_input = document.getElementById('superbed-upload-box-input');
        superbed_upload_input.addEventListener("change", () => {
            const files = superbed_upload_input.files;
            for (let i = 0; i < files.length; i++) {
                const file = files[i];
                const formData = new FormData();
                formData.append('file', file);
                formData.append('token', "<?php echo get_option('token'); ?>");
                formData.append('categories', "<?php echo get_option('categories'); ?>");
                document.getElementById('superbed-upload-box-input').disabled = true;
                document.getElementById('superbed-upload-box').innerHTML = '正在上传中...';
                axios({
                    method: 'post',
                    url: 'https://api.superbed.cc/upload',
                    data: formData,
                    headers: {
                        'Access-Control-Allow-Origin': '*',
                        'Access-Control-Allow-Methods': 'POST',
                        'Access-Control-Allow-Headers': 'Content-Type',
                        'Accept': 'application/json',
                        'Content-Type': 'multipart/form-data',
                    }
                }).then(response => {
                    const data = response.data;
                    if (data.err == 0) {
                        const url = data.url;
                        const name = data.name;
                        const input = document.createElement('input');
                        input.type = 'text';
                        input.value = url;
                        document.getElementById('result').appendChild(input);
                        input.addEventListener('click', function () {
                            input.select();
                            document.execCommand('copy');
                            showToast("链接已复制到剪切板");
                        });
                        copyData(url);
                        document.getElementById('superbed-upload-box-input').disabled = false;
                        document.getElementById('superbed-upload-box').innerHTML = '点击此区域上传图片';
                    } else {
                        showToast(data.msg);
                        document.getElementById('superbed-upload-box-input').disabled = false;
                        document.getElementById('superbed-upload-box').innerHTML = data.msg;
                    }
                }).catch(error => {
                    showToast("网络错误请重试");
                    console.log(error);
                    document.getElementById('superbed-upload-box-input').disabled = false;
                    document.getElementById('superbed-upload-box').innerHTML = '点击此区域上传图片';
                });
            }
        });
    </script>
<?php } ?>
